mod Ex02b logic: 'cl'

incl Mtex

loc rem 
  2. CVICENIE Z PREDMETU SPECIFIKACIA A VERIFIKACIA PROGRAMOV

rem 
  VASE MENO: ?
  SKUPINA: ?
  VERZIA CL: 5.81.16
  DATUM: stvrtok 24.2.2005
  ******************************************************************************
  SKUSKA (toto je len zakladny ramec, viz. tiez 1. prednaska):
   A = aspon 90 bodov
   B = aspon 80 bodov
   C = aspon 70 bodov
   D = aspon 60 bodov
   E = aspon 50 bodov
  ******************************************************************************
  PMAIL: svp@nw.fmph.uniba.sk
         SUBJECT: prihlasenie sa do skupiny [14:50,16:30,18:10]
  WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/svp

rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane rekurzii s mierou 
  a chvostovej rekurzii. Zadanie sa sklada z tychto suborov: 
  \items 
   \item \para Subor \it  mtex.cl  \end obsahuje makra pre CL-TeX. 
   \item \para Subor(y) \it  maux*.cl  \end obsahuju definicie a vlastnosti 
         pomocnych funkcii a predikatov. 
   \item \para Subor(y) \it  ex02*.cl  \end obsahuju ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

fun/0 Foo 'Tex_f0_foo'
  Foo = 0

pred/0 Poo 'Tex_p0_poo'
  Poo <-> \f

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  Chapter. Numeric Programs.  \end 

rem 
  \para \bf  Section. Primitive Recursion.  \end 

rem 
  \para \bf  Primitive recursion with substitution in parameters.  \end 

rem 
  \para \bf  Summation function.  \end 

fun Sum 'Tex_f1_pa_sum'
  Sum(0) = 0
  Sum(n+1) = Sum(n)+n+1

rem 
  \para \bf  Exercise.  \end 

fun/2 Suma 'Tex_f2_f'
  Suma(0,a) = a
  Suma(n+1,a) = Suma(n,a+n+1)

rem 
  \para Prove 
  \eq Sum_by_suma
    Sum(n) = Suma(n,0)
  \end

thm Sum_by_suma
  Sum(n) = Suma(n,0)

rem 
  \para \bf  Factorial.  \end 

fun Fact 'Tex_f1_pa_fact'
  Fact(0) = 1
  Fact(n+1) = (n+1)*Fact(n)

rem 
  \para \bf  Exercise.  \end 

fun/2 Facta 'Tex_f2_f'
  Facta(0,a) = a
  Facta(n+1,a) = Facta(n,(n+1)*a)

rem 
  \para Prove 
  \eq Fact_by_facta
    Fact(n) = Facta(n,1)
  \end

thm Fact_by_facta
  Fact(n) = Facta(n,1)

rem 
  \para \bf  Fibonacci function.  \end 

fun Fib 'Tex_f1_pa_fib'
  Fib(0) = 0
  Fib(1) = 1
  Fib(n+2) = Fib(n+1)+Fib(n)

rem 
  \para \bf  Exercise.  \end 

fun/3 Fiba 'Tex_f3_f'
  Fiba(0,a,b) = b
  Fiba(n+1,a,b) = Fiba(n,a+b,a)

rem 
  \para Prove 
  \eq Fib_by_fiba
    Fib(n) = Fiba(n,1,0)
  \end

thm Fib_by_fiba
  Fib(n) = Fiba(n,1,0)

rem 
  \para \bf  Exercise.  \end 

fun F1 'Tex_f1_f_sub'
  F1(0) = 0
  F1(1) = 1
  F1(2) = 2
  F1(n+3) = F1(n+2)+F1(n+1)+F1(n)

fun/4 Fa1 'Tex_f4_g'
  Fa1(0,a,b,c) = c
  Fa1(n+1,a,b,c) = Fa1(n,a+b+c,a,b)

rem 
  \para Prove 
  \eq F1_by_fa1
    F1(n) = Fa1(n,2,1,0)
  \end

thm F1_by_fa1
  F1(n) = Fa1(n,2,1,0)

rem 
  \para \bf  Exercise.  \end 

fun F2 'Tex_f1_f_sub'
  F2(0) = 0
  F2(1) = 1
  F2(n+2) = F2(n+1)+F2(n)+n

fun/4 Fa2 'Tex_f4_g'
  Fa2(0,i,a,b) = b
  Fa2(n+1,i,a,b) = Fa2(n,i+1,a+b+i,a)

rem 
  \para Prove 
  \eq F2_by_fa2
    F2(n) = Fa2(n,0,1,0)
  \end

thm F2_by_fa2
  F2(n) = Fa2(n,0,1,0)

rem 
  \para \bf  Exercise.  \end 

fun F3 'Tex_f1_f_sub'
  F3(0) = 0
  F3(1) = 1
  F3(2) = 2
  F3(3) = 3
  F3(n+4) = 2*F3(n+3)+F3(n+2)+n*F3(n+1)+F3(n)+n*(n+1)+4

rem 
  \para Find a more efficient implementation of the function \ft F3(n) \end and 
  prove its correctness. 

rem 
  \para \bf  Section. Course of Values Recursion.  \end 

rem 
  \para \bf  Course of values recursive definitions with measure.  \end 

rem 
  \para \bf  Simulation of for-loops by recursion.  \end 

fun/3 Suma1 'Tex_f3_f'
  Suma1(n,j,a) = a <- j > n
  Suma1(n,j,a) = Suma1(n,j+1,a+j) <- j <= n

rem 
  \para Prove 
  \eq Sum_by_suma1
    Sum(n) = Suma1(n,1,0)
  \end

thm Sum_by_suma1
  Sum(n) = Suma1(n,1,0)

rem 
  \para \bf  Exercise.  \end 

fun/3 Suma2 'Tex_f3_f'
  Suma2(n,j,a) = a <- j >= n
  Suma2(n,j,a) = Suma2(n,j+1,a+j+1) <- j < n

rem 
  \para Prove 
  \eq Sum_by_suma2
    Sum(n) = Suma2(n,0,0)
  \end

thm Sum_by_suma2
  Sum(n) = Suma2(n,0,0)

rem 
  \para \bf  Exercise.  \end 

fun/3 Facta1 'Tex_f3_f'
  Facta1(n,i,a) = a <- i > n
  Facta1(n,i,a) = Facta1(n,i+1,i*a) <- i <= n

rem 
  \para Prove 
  \eq Fact_by_facta1
    Fact(n) = Facta1(n,1,1)
  \end

thm Fact_by_facta1
  Fact(n) = Facta1(n,1,1)

rem 
  \para \bf  Exercise.  \end 

fun/3 Facta2 'Tex_f3_f'
  Facta2(n,i,a) = a <- i >= n
  Facta2(n,i,a) = Facta2(n,i+1,(i+1)*a) <- i < n

rem 
  \para Prove 
  \eq Fact_by_facta2
    Fact(n) = Facta2(n,0,1)
  \end

thm Fact_by_facta2
  Fact(n) = Facta2(n,0,1)

